# If for whatever reason this doesn't work, check this file:
Start-Transcript -path "D:\ServerSetupLog.txt" -append

# Get variables we need
$availabilityZone = Invoke-WebRequest http://169.254.169.254/latest/meta-data/placement/availability-zone -UseBasicParsing 
$Region = $availabilityZone.Content.Trim("a","b","c")
$instanceId = (Invoke-RestMethod -Method Get -Uri http://169.254.169.254/latest/meta-data/instance-id)

Write-Output "Using Region $Region"
Write-Output "Using InstanceId $instanceId"

# Download All files from S3
$sourceBucketName = "YOUR_S3_BUCKET_NAME_HERE"
$keyPrefix = "Scripts"
$localPath = "C:\temp\"

Set-Location $localPath

$objects = get-s3object -bucketname $sourceBucketName -KeyPrefix $keyPrefix
foreach($object in $objects) 
{
    $localFileName = $object.Key -replace $keyPrefix, ''
	if ($localFileName -ne '' -and $localFileName -ne '/') 
	{
		$localFilePath = Join-Path $localPath $localFileName
		Write-Output "Copying File " $localFileName " to " $localFilePath
		Copy-S3Object -BucketName $sourceBucketName -Key $object.Key -LocalFile $localFilePath
	}
}

# Import any needed modules here
Import-Module AWSPowerShell
Import-Module .\MyEC2Instance #this is a custom cmdlet that only serves to get local instance tags using the Get-Tag command.

& .\SetTags.ps1
& .\InstallCertificates.ps1
Set-Location $localPath
& .\InstallTentacle.ps1
& .\AddOctopusMachineIdTag.ps1
& .\AutoDeploy.ps1
Write-Output "Deployment complete."

# Write the tentacle installation log to S3
Write-S3Object -bucketname pelican-deploy -File D:\ServerSetupLog.txt -key ServerSetupLogs/$instanceId/ServerSetupLog.txt